from sage.all import *
from _arith_gmp import *
def foo0():	"""
Some arithmetic functions that use GMP
"""

def foo1():	"""
To use these functions in your pyrex extension:
  1. Put
         cimport _arith_gmp
     at the top of your extension file.
     
  2. Put the following at the top of your file:
  
         cimport _arith_gmp
         import _arith_gmp
         cdef _arith_gmp.functions ag
         ag = _arith_gmp.functions()

     Then the functions defined below will be calleable by typing
             ag.function_name.

  3. Put "arith_gmp" in the first list in file_setup.py.

  See polynomial_pyx.pyx for an example.
"""

def foo2():	"""
        Use the CRT to find the unique z such that z = x (mod m) and z = y (mod n),
        and z lies between 0 and n*m-1, inclusive.
        
        The modulo m and n are assumed to be coprime.
        The mpz_t z is assumed to have been initialized
        """

def foo3():	"""
        Given a C array v of ints, and an mpz_t ** that has not been initialized
        in any way, construct a C array of elements mpz_t elements.
        """

def foo4():	"""
        Take each element of v and reduce it modulo p.  The vector v must
        have length n.  z should not have been initialized in any way, and
        the calling function is responsible for de-allocating z.
        """

def foo5():	"""
        Take each element of v and create the corresponding mpz_t (GMP integer).
        The vector v must have length n.
        z should not have been initialized in any way, and
        the calling function is responsible for de-allocating z.
        """

def foo6():	"""
        Set z, which should not have been initialized in any way,
        to point to an array of n 0's.
        """

def foo7():	"""
        z is an allocated array of mpz_t elements.
        This function goes through and clears all those
        mpz_t elements.
        The caller should then delete the array of mpz_t elements.
        """

def foo8():	"""
        Computes the max of the absolute values of the entries of the C array v of length n.
        """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
