from sage.all import *
from _dense_matrix_pyx import *
def foo0():	"""
Dense matrices over F_p and Q.
"""

def foo1():	"""
    Convert an mpq to an integer modulo n.  There is substantial
    overhead because three mpq_t variables must be initialized and
    cleared each time this function is called.
    """

def foo2():	"""
        Return the rank found during the last echelon operation on self.
        Of course if self is changed, then the rank could be incorrect.
        """

def foo3():	"""
        Return the pivots found during the last echelon operation on self.
        Of course if self is changed, then the pivots could be incorrect.
        """

def foo4():	"""
    Compare two sequences of pivot columns.
    If x is short than y, return -1, i.e., x < y, "not as good".
    If x is longer than y, x > y, "better"
    If the length is the same then x is better, i.e., x > y
        if the entries of x are correspondingly >= those of y with
        one being greater.
    I
    """

def foo5():	"""
    Matrix over the rational numbers.
    """

def foo6():	"""
        Changes self into echelon form.
        """

def foo7():	"""
        Return the rank found during the last echelon operation on self.
        Of course if self is changed, and the echelon form of self is not
        recomputed, then the rank could be incorrect.
        """

def foo8():	"""
        Return the pivots found during the last echelon operation on self.
        Of course if self is changed, and the echelon form of self is not
        recomputed, then the pivots could be incorrect.
        """

def foo9():	"""
        Returns self if the denominator is 1, or n*self, where n is
        the denominator of self.
        """

def foo10():	"""
        Replace self by n*self, where n is the least common multiple
        of the denominators of all entries of self.  
        """

def foo11():	"""
        echelon(self, alg="modular", height_guess=None):
        
        Returns echelon form of self, without modifying self.
        """

def foo12():	"""
        echelon_modular(self, height_guess=None):
        
        Returns echelon form of self, without modifying self.  Uses a
        multi-modular method.

        ALGORITHM:
        The following is a modular algorithm for computing the echelon
        form.  Define the height of a matrix to be the max of the
        absolute values of the entries.

        Input: Matrix A with n columns (this).
        
        0. Rescale input matrix A to have integer entries.  This does
           not change echelon form and makes reduction modulo many
           primes significantly easier if there were denominators.
           Henceforth we assume A has integer entries. 
           
        1. Let c be a guess for the height of the echelon form.  E.g.,
           c=1000, since matrix is sparse and application is modular
           symbols.

        2. Let M = n * c * H(A) + 1,
           where n is the number of columns of A.

        3. List primes p_1, p_2, ..., such that the product of
           the p_i is at least M.

        4. Try to compute the rational reconstruction CRT echelon form
           of A mod the product of the p_i.  Throw away those A mod p_i
           whose pivot sequence is not >= all other pivot sequences of
           A mod p_j.
           If rational reconstruction fails, compute 1 more echelon
           forms mod the next prime, and attempt again.  Let E be this
           matrix.

        5. Compute the denominator d of E.
           Try to prove that result is correct by checking that
           
                 H(d*E) < (prod of reduction primes)/(ncols*H(A)),

           where H denotes the height.   If this fails, do step 4 with
           a few more primes.

           (TODO: Possible idea for optimization: When doing the rational_recon lift,
            keep track of the lcm d of denominators found so far, and given
                             a (mod m)
            first check to see if a*d lifts to an integer with abs <= m/2.
            If so, no nded to do rational recon.  This should be the case
            for most a after a while, and should save substantial time!!!!)
        """

def foo13():	"""
    Matrix_rational_using_crt_and_rr(X):

    Uses the Chinese remainder theorem to combine the matrices in the input list
    into a single matrix modulo the product of the moduli, the lifts to Q using
    rational reconstruction.  Returns a Matrix_rational on success, or raises
    a ValueError exception on failure (i.e., of the rational reconstruction
    does not exists).

    INPUT:
        X -- a nonempty list of Matrix_modint's.  The moduli must be
                    distinct primes.

    OUTPUT:
        a single Matrix_rational, which reduces to each of the
        input Matrix_modint's.
    """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
