from sage.all import *
from _p1list import *
def foo0():	"""
List of elements of P1(Z/NZ)
"""

def foo1():	"""
    Do not compute s if compute_s == 0.
    """

def foo2():	"""
    p1_normalize_int(N, u, v):
    
    Computes the canonical representative of P^1(Z/NZ) equivalent
    to (u,v) along with a transforming scalar. 

    INPUT:
        N -- an integer
        u -- an integer
        v -- an integer
    OUTPUT:
        If gcd(u,v,N) = 1, then returns
             uu -- an integer
             vv -- an integer
             ss -- an integer
             such that (ss*uu, ss*vv) is equivalent to (u,v) mod N
        and if gcd(u,v,N) != 1, returns
             0, 0, 0
    """

def foo3():	"""
    p1list_int(int N):
    
    Make a list of the normalized elements of P^1(Z/NZ).
    """

def foo4():	"""
    Do not compute s if compute_s == 0.
    """

def foo5():	"""
    p1_normalize_llong(N, u, v):
    
    Computes the canonical representative of P^1(Z/NZ) equivalent
    to (u,v) along with a transforming scalar. 

    INPUT:
        N -- an integer
        u -- an integer
        v -- an integer
    OUTPUT:
        If gcd(u,v,N) = 1, then returns
             uu -- an integer
             vv -- an integer
             ss -- an integer
             such that (ss*uu, ss*vv) is equivalent to (u,v) mod N
        and if gcd(u,v,N) != 1, returns
             0, 0, 0
    """

def foo6():	"""
    p1list_llong(int N):
    
    Make a list of the normalized elements of P^1(Z/NZ).
    """

def foo7():	"""
        Returns the index of the class of (u,v) in the fixed list of
        representatives of P^1(Z/NZ).
        INPUT:
            u, v -- integers, with GCD(u,v,N)=1.
        OUTPUT:
            i -- the index of u, v, in the P^1 list.
        """

def foo8():	"""
        Returns the index of the class of (u,v) in the fixed list of
        representatives of P^1(Z/NZ).
        INPUT:
            u, v -- integers, with GCD(u,v,N)=1 normalized so they lie in the list.
        OUTPUT:
            i -- the index of u, v, in the P^1 list.
        """

def foo9():	"""
        Returns the index of the class of (u,v) in the fixed list of
        representatives of P^1(Z/NZ).
        INPUT:
            u, v -- integers, with GCD(u,v,N)=1.
        OUTPUT:
            i -- the index of u, v, in the P^1 list.
            s -- scalar that transforms normalized form to u,v
        """

def foo10():	"""
        normalize_with_scalar(self, int u, int v)
        
        INPUT:
            u, v -- integers, with GCD(u,v,N)=1.
        OUTPUT:
            uu, vv -- integers of *normalized* rep
            ss -- scalar such that (ss*uu, ss*vv) = (u,v) mod N
        """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
