from sage.all import *
from _polynomial_pyx import *
def foo0():	"""
Polynomial rings.
"""

def foo1():	"""
    Set g equal to f.  We assume g has already been initialized.
    """

def foo2():	"""
    Computes the sum of f and g and places the result in sum.`
    Note that sum must have been initialized.
    """

def foo3():	"""
    Computes the difference f - g and places the result in sum.`
    Note that sum must have been initialized.
    """

def foo4():	"""
    Replaces f by a*f.
    """

def foo5():	"""
    Sets g fo a*f.
    """

def foo6():	"""
    Computes the product of f and g and places the result in prod.`
    Note that prod must have been initialized.
    """

def foo7():	"""
    Used by Pmodint_mul_karatsuba:
       A = f[e:]
       B = f[:e]
    """

def foo8():	"""
    Computes the product of f and g using Karatsuba multiplication.
    Note that prod must have been initialized.

    The basic idea is to use that

       (a*X+b)*(c*X+d) = ac*X^2+((a+b)*(c+d)-ac-bd)*X+bd

    where ac=a*c and bd=b*d, which requires three
    multiplications instead of the naive four.  (In my examples,
    strangely just doing the above with four multiplications
    does tend to speed things up noticeably.)
    Given f and g of arbitrary degree bigger than one, let e
    be min(deg(f),deg(g))/2.  Write

          f = a*X^e + b    and    g = c*X^e + d

    and use the identity

         (a*X^e+b)*(c*X^e+d) = ac*X^(2e) +((a+b)*(c+d)-ac-bd)*X^e + bd

    to recursively compute f*g.

    TIMINGS:
    On a Pentium M 1.8Ghz laptop:

    NOTES:
        * Karatsuba multiplication of polynomials is also implemented in PARI in
          src/basemath/polarit3.c.
 
        * A much more readable pure python version is in python/rings.py
        
    """

def foo9():	"""
    Sets the coefficient of x^n in the polynomial to c.  Does not
    steal a reference to c.
    """

def foo10():	"""
    Polynomial_modint():

    Polynomials over the integers modulo p.
    """

def foo11():	"""
    Set g equal to f.  We assume g has already been initialized.
    """

def foo12():	"""
    Computes the sum of f and g and places the result in sum.`
    Note that sum must have been initialized.
    """

def foo13():	"""
    Computes the sum of f and g and places the result in sum.`
    Note that sum must have been initialized.
    """

def foo14():	"""
    Replaces f by a*f.
    """

def foo15():	"""
    Sets g fo a*f.
    """

def foo16():	"""
    Computes the product of f and g and places the result in prod.`
    Note that prod must have been initialized.
    """

def foo17():	"""
    Used by PQ_mul_karatsuba:
       A = f[e:]
       B = f[:e]
    """

def foo18():	"""
    Computes the product of f and g using Karatsuba multiplication.
    Note that prod must have been initialized.

    The basic idea is to use that

       (a*X+b)*(c*X+d) = ac*X^2+((a+b)*(c+d)-ac-bd)*X+bd

    where ac=a*c and bd=b*d, which requires three
    multiplications instead of the naive four.  (In my examples,
    strangely just doing the above with four multiplications
    does tend to speed things up noticeably.)
    Given f and g of arbitrary degree bigger than one, let e
    be min(deg(f),deg(g))/2.  Write

          f = a*X^e + b    and    g = c*X^e + d

    and use the identity

         (a*X^e+b)*(c*X^e+d) = ac*X^(2e) +((a+b)*(c+d)-ac-bd)*X^e + bd

    to recursively compute f*g.

    TIMINGS:
    On a Pentium M 1.8Ghz laptop:

    NOTES:
        * Karatsuba multiplication of polynomials is also implemented in PARI in
          src/basemath/polarit3.c.
 
        * A much more readable pure python version is in python/rings.py
        
    """

def foo19():	"""
    Sets den equal to the least common multiple of the denominators
    of the coefficients of f, and vec equal to the coefficients
    of den*f.  This function assumes that vec has *not*
    been initialized in any way, but den better have been initialized.

    Raises a MemoryError exception, if this function fails to allocate
    the memory needed for the numerators.
    """

def foo20():	"""
    Convert a GMP integer to a Python string.
    """

def foo21():	"""
    Computes the product of f and g and places the result in prod.
    Uses a multi-modular method.
    Note that prod must have been initialized already.

    PERFORMANCE:
       On a 1.8Ghz Pentium-M laptop.  It's comparable to PARI, and
       when the degree is large it is much better.  MAGMA wins in
       all cases, but that's maybe due to it using an FFT algorithm?
       The times suggest this code is at least usable in practice.
       It's much faster than pure python.
       
       Multiplying sum_{n=0}^{10000} (n/19)*x^n by times itself.
       THIS Function     PARI       MAGMA    (time in seconds)
       1.56              7.78       0.12

       Multiplying x^20 + 19/5*x^7 + 1 by x^35 + 2*x + 1  10000 times.
       THIS              PARI       MAGMA      (PURE PYTHON)
       0.63              0.15       0.09        27 seconds

       Multiplying sum_{n=0}^100 n*x^n by sum_{n=0}^100 (100-n)*x^n 1000 times
       THIS              PARI       MAGMA
       0.64              0.748      0.21

       Multiplying sum_{n=1}^100 1/n * x^n by itself 100 times
       THIS              PARI       MAGMA
       1.14              0.716      0.333
    """

def foo22():	"""
    Sets the coefficient of x^n in the polynomial to c.  Does not
    steal a reference to c.
    """

def foo23():	"""
    Polynomial_rational():

    Create the zero polynomial over the rational numbers.
    """

def foo24():	"""
#         Division with remainder.  Returns a tuple (quotient, remainder).
#         """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
