from sage.all import *
from _sparse_matrix_pyx import *
def foo0():	"""
Sparse matrices
"""

def foo1():	"""
    Allocate memory for a c_vector_modint -- most user code won't call this.
    """

def foo2():	"""
    Initialize a c_vector_modint -- most user code *will* call this.
    """

def foo3():	"""
    Find the position of the integer x in the array v, which has length n.
    Returns -1 if x is not in the array v.

    (This is a drop-in replacement for binary_search0, which we do
    not use in practice.  I just wrote it to make sure binary_search0
    was working correctly.)
    """

def foo4():	"""
    Find the position of the integer x in the array v, which has length n.
    Returns -1 if x is not in the array v.
    """

def foo5():	"""
    Find the position of the integer x in the array v, which has length n.
    Returns -1 if x is not in the array v, and in this case ins is
    set equal to the position where x should be inserted in order to
    get the array ordered.

    (This is a drop-in replacement for binary_search, which we do
    not use in practice.  I just wrote it to make sure binary_search
    was working.)
    """

def foo6():	"""
    Find the position of the integer x in the array v, which has length n.
    Returns -1 if x is not in the array v, and in this case ins is
    set equal to the position where x should be inserted in order to
    obtain an ordered array.
    """

def foo7():	"""
    Returns the n-th entry of the sparse vector v.  This
    would be v[n] in Python syntax.
    """

def foo8():	"""
    Returns a Python list of 2-tuples (i,x), where x=v[i] runs
    through the nonzero elements of x, in order.
    """

def foo9():	"""
    Set the n-th component of the sparse vector v equal to x.
    This would be v[n] = x in Python syntax. 
    """

def foo10():	"""
    Set sum = v + multiple*w.
    """

def foo11():	"""
    Vector_modint -- a sparse vector modulo p.  This is a Python
    extension type that wraps the C implementation of sparse vectors
    modulo a small prime.
    """

def foo12():	"""
        randomize(self, int sparcity, exact=False):

        The sparcity is a bound on the number of nonzeros per row.
        """

def foo13():	"""
        p should be a prime <46340 and entries should be a list of triples
        (i,j,x), where 0 <= i < nrows, 0 <= j < ncols, and x is an integer
        which need not be reduced modulo p.  Then the i,j entry of the matrix
        is set to x.  It is OK for some x to be zero.
        """

def foo14():	"""
        Return an associative arrow of pairs
               n:x
        where the keys n run through the nonzero positions of the row,
        and the x are nonzero and of type Integer.
        """

def foo15():	"""
        Return an associative arrow of pairs
               (i,j):x
        where the keys (i,j) run through the nonzero positions of the matrix
        and the x are nonzero and of type Integer.
        """

def foo16():	"""
        randomize(self, int sparcity, exact=False):
        
        The sparcity is a bound on the number of nonzeros per row.
        """

def foo17():	"""
        Swap the rows in positions n1 and n2
        """

def foo18():	"""
        Replace self by its reduction to reduced row echelon form.
        ALGORITHM:
        We use Gauss elimination, which is slightly intelligent, in these
        sense that we clear each column using a row with the minimum number
        of nonzero entries.  
        """

def foo19():	"""
    Allocate memory for a mpq_vector -- most user code won't call this.
    num_nonzero is the number of nonzero entries to allocate memory for.

    This function *does* call mpq_init on each mpq_t that is allocated.
    It does *not* clear the entries of v, if there are any.
    """

def foo20():	"""
    Initialize a mpq_vector -- most user code *will* call this.
    """

def foo21():	"""
    Find the position of the rational x in the array v, which has length n.
    Returns -1 if x is not in the array v.
    """

def foo22():	"""
    Find the position of the integer x in the array v, which has length n.
    Returns -1 if x is not in the array v, and in this case ins is
    set equal to the position where x should be inserted in order to
    obtain an ordered array.
    INPUT:
       v -- array of mpq_t  (rational)
       n -- integer (length of array v)
       x -- mpq_t  (rational)
    OUTPUT:
       position of x (as an int)
       ins -- (call be pointer), the insertion point if x is not found.
    """

def foo23():	"""
    Returns the n-th entry of the sparse vector v.  This
    would be v[n] in Python syntax.

    The return is done using the pointer ans, which is to an mpq_t
    that *must* have been initialized using mpq_init.
    """

def foo24():	"""
    Returns a Python list of 2-tuples (i,x), where x=v[i] runs
    through the nonzero elements of x, in order.
    """

def foo25():	"""
    Set the n-th component of the sparse vector v equal to x.
    This would be v[n] = x in Python syntax. 
    """

def foo26():	"""
    Set the n-th component of the sparse vector v equal to x.
    This would be v[n] = x in Python syntax. 
    """

def foo27():	"""
    Initialize sum and set sum = v + multiple*w.
    """

def foo28():	"""
    Vector_mpq -- a sparse vector of GMP rationals.  This is a Python
    extension type that wraps the C implementation of sparse vectors
    modulo a small prime.
    """

def foo29():	"""
        randomize(self, int sparcity, exact=False):
        
        The sparcity is a bound on the number of nonzeros per row.
        """

def foo30():	"""
        entries should be a list of triples (i,j,x), where 0 <= i <
        nrows, 0 <= j < ncols, and x is a rational number.  Then the
        i,j entry of the matrix is set to x.  It is OK for some x to
        be zero.
        """

def foo31():	"""
        Return an associative arrow of pairs
               n:x
        where the keys n run through the nonzero positions of the row,
        and the x are nonzero and of type Integer.
        """

def foo32():	"""
        Return an associative arrow of pairs
               (i,j):x
        where the keys (i,j) run through the nonzero positions of the matrix
        and the x are nonzero and of type Integer.
        """

def foo33():	"""
        randomize(self, int sparcity):
        
        The sparcity is a bound on the number of nonzeros per row.
        """

def foo34():	"""
        Swap the rows in positions n1 and n2
        """

def foo35():	"""
        Replace self by its reduction to reduced row echelon form.
        
        ALGORITHM:
        We use Gauss elimination, which is slightly intelligent, in these
        sense that we clear each column using a row with the minimum number
        of nonzero entries.

        WARNING: There is no reason to use the code below, except
                 for testing this class.  It is *vastly* faster to use
                 the multi-modular method, which is implemented in
                 sparse_matrix.Sparse_matrix_rational
        """

def foo36():	"""
    Create a sparse Matrix_mpq from a list of sparse Vector_mpq's.  
    Each vector must have same degree.
    INPUT:
        columns -- a list of Vector_mpq's.
    OUTPUT:
        A sparse Matrix_mpq whose columns are as given.
    """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
